/*
* Template: src/main/takatuka/templates/EntityPresentationAbstractSearchView.vm
*/
package de.ivu.elect.presentation.benutzerverwaltung;

import java.util.List;

import javax.annotation.PostConstruct;
import javax.enterprise.context.RequestScoped;
import javax.enterprise.event.Observes;
import javax.enterprise.event.Reception;
import javax.enterprise.inject.Instance;
import javax.faces.context.FacesContext;
import javax.inject.Inject;
import javax.inject.Named;

import org.apache.deltaspike.core.api.scope.ConversationGroup;
import org.apache.deltaspike.core.api.scope.ViewAccessScoped;

import de.ivu.elect.business.security.UseCasePermission;

import de.ivu.elect.business.benutzerverwaltung.boundary.AbstractNachrichtSearchParameters;
import de.ivu.elect.business.benutzerverwaltung.boundary.NachrichtChangeEvent;
import de.ivu.elect.business.benutzerverwaltung.boundary.NachrichtConversationStore;
import de.ivu.elect.business.benutzerverwaltung.boundary.NachrichtExtendedDAO;
import de.ivu.elect.business.benutzerverwaltung.boundary.NachrichtSearch;
import de.ivu.elect.business.benutzerverwaltung.boundary.NachrichtSearchParameters;
import de.ivu.elect.business.wahl.boundary.WahlSelectChangeEvent;
import de.ivu.elect.business.wahl.boundary.WahlterminSelectChangeEvent;
import de.ivu.elect.business.benutzerverwaltung.entity.Nachricht;
import de.ivu.elect.business.benutzerverwaltung.entity.NachrichtMeta;
import de.ivu.elect.jee.entity.EagerLoadingCollector;
import de.ivu.elect.presentation.AbstractElectSearchView;
import de.ivu.elect.presentation.View;

@ViewAccessScoped
@Named(AbstractNachrichtSearchView.COMPONENT_NAME)
@View(viewId = AbstractNachrichtSearchView.VIEW_ID, useCase = UseCasePermission.NACHRICHT_SEARCH)
public abstract class AbstractNachrichtSearchView extends AbstractElectSearchView<Nachricht> {

  private static final long serialVersionUID = 1L;

  public static final String COMPONENT_NAME = "nachrichtSearchView";
  
  public static final String VIEW_ID = "/benutzerverwaltung/nachricht-search.xhtml";

  @Inject
  private transient RequestHandlerAbstractNachrichtSearchView requestHandler;

  @Inject
  private transient NachrichtExtendedDAO extendedDAO;

  @Inject
  @ConversationGroup(NachrichtConversationStore.class)
  protected transient NachrichtConversationStore conversationStore;

  @Inject
  protected transient NachrichtSearch search;

  @Inject
  @ConversationGroup(AbstractNachrichtSearchParameters.class)
  protected transient NachrichtSearchParameters searchParameters;

  @Inject
  protected transient NachrichtMeta entityMeta;

  public AbstractNachrichtSearchView() {
    super();
  }

  @Override
  protected String getViewId() {
    return VIEW_ID;
  }

  public boolean isEntitySelected() {
    return conversationStore.getEntityPK() != null;
  }

  public Nachricht getSelectedEntity() {
    if (isEntitySelected()) {
      return extendedDAO.findByPrimaryKey(conversationStore.getEntityPK());
    }

    return null;
  }

  public void setSelectedEntity(Nachricht entity) {
    if (entity == null) {
      conversationStore.setEntityPK(null);
    } else {
      conversationStore.setEntityPK(entity.getPk());
    }
  }

  @Override
  public NachrichtSearchParameters getSearchParameters() {
    return searchParameters;
  }

  public EagerLoadingCollector<Nachricht> getEagerLoadingCollector() {
    return EagerLoadingCollector.<Nachricht> create();
  }

  @Override
  public List<Nachricht> getSearchResult() {
    requestHandler.nothing(); // ELECT-248

    return super.getSearchResult();
  }

  @Override
  protected List<Nachricht> performSearch() {
    return search.getSearchResult(getSearchParameters(), getEagerLoadingCollector());
  }

  public void onNachrichtChangeEvent(@Observes(notifyObserver = Reception.IF_EXISTS) NachrichtChangeEvent event) {
    resetSearchResult();
  }

  // ELECT-2231    ELECT-2250
  /*
   * searchParameters sind von der zur Bearbeitung ausgewählten Wahl abhängig.
   */
  public void onWahlSelectChangeEvent(@Observes(notifyObserver = Reception.IF_EXISTS) WahlSelectChangeEvent event) {
    reset();
  }

  /*
   * searchParameters sind vom zur Bearbeitung ausgewählten Wahltermin abhängig.
   */
  public void onWahlterminSelectChangeEvent(@Observes(notifyObserver = Reception.IF_EXISTS) WahlterminSelectChangeEvent event) {
    reset();
  }

  @RequestScoped
  // elect: Das Suchergebnis soll nur einmal pro Request geladen werden, daher gibt es dieses "Konstrukt" aus "SearchView" und "RequestHandlerAbstract"
  public static class RequestHandlerAbstractNachrichtSearchView {

    @View
    @Inject
    private transient Instance<AbstractNachrichtSearchView> searchViews;

    @PostConstruct
    public void init() {
      // ELECT-3543 Doppelte Suchen vermeiden - Suchergebnis für Request nicht beim POST-löschen
      if (!FacesContext.getCurrentInstance().isPostback()) {
        for (AbstractNachrichtSearchView searchView : searchViews) {
          searchView.resetSearchResult();
        }
      }
    }

    public void nothing() {
      // Do nothing.
    }
  }
}
